#include <vector>
#include <thread>
#include <future>
#include <numeric>
#include <iostream>
#include <chrono>

void accumulate(const std::vector<int>& vec,
                std::promise<int> accumulate_promise) {
    int sum = std::accumulate(vec.begin(), vec.end(), 0);
    std::this_thread::sleep_for(std::chrono::seconds(1));
    accumulate_promise.set_value(sum);  // Notify future
    std::this_thread::sleep_for(std::chrono::seconds(1));
}

int main()
{
    std::vector numbers = { 42, 17, 0, -3, 5, 11, 19, 007, 100 };
    std::promise<int> accumulate_promise;
    std::future<int> accumulate_future = accumulate_promise.get_future();
    std::thread worker(accumulate, std::cref(numbers),
                       std::move(accumulate_promise));

    accumulate_future.wait();  // wait for result
    std::cout << "result=" << accumulate_future.get() << '\n';
    worker.join();  // wait for the thread to finish
}
